/*

** str.d

** Copyright (C) 2003 Helmut Leitner

** Donated to Digital Mars.

** Released under the GNU GPL, see LICENSE.TXT

** and http://www.gnu.org/copyleft/gpl.html

*/



module venus.str;

import venus.all;



alias char[] Str;



void StrCpyMem(inout Str d,char *buf,int n) {

    d.length=n;

    d[0..n]= buf[0..n];

}



void StrCatMem(inout Str d,char *buf,int n) {

    int dlen=d.length;

    d.length=d.length+n;

    d[dlen..dlen+n]= buf[0..n];

}



//=========



void StrCpy(inout Str s,Tpi tpi) {

   char buf[80];

   int n=tpi.ptm.gets(tpi.pv,buf);

   StrCpyMem(s,buf,n);

}



void StrCpy(inout Str s,char    t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,byte    t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,ubyte   t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,short   t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,ushort  t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,int     t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,uint    t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,long    t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,ulong   t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,float   t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,double  t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,ifloat  t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,idouble t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,cfloat  t) {  StrCpy(s,TypeRetTpi(t));  }

void StrCpy(inout Str s,cdouble t) {  StrCpy(s,TypeRetTpi(t));  }



void StrCpy(inout Str d,Str s) {

    d.length=s.length;

    d[0..s.length]= s[0..s.length];

}



void StrCpy(inout Str d,Object o) {

    StrCpy(d,o.toString());

}



//=========



void StrCat(inout Str s,Tpi tpi) {

   char buf[80];

   int n=tpi.ptm.gets(tpi.pv,buf);

   StrCatMem(s,buf,n);

}



void StrCat(inout Str s,char    t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,byte    t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,ubyte   t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,short   t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,ushort  t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,int     t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,uint    t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,long    t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,ulong   t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,float   t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,double  t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,ifloat  t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,idouble t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,cfloat  t) {  StrCat(s,TypeRetTpi(t));  }

void StrCat(inout Str s,cdouble t) {  StrCat(s,TypeRetTpi(t));  }



void StrCat(inout Str d,Str s) {

    int dlen=d.length;

    d.length=d.length+s.length;

    d[dlen..dlen+s.length]=s[0..s.length];

}



void StrCat(inout Str d,Object o) {

    StrCat(d,o.toString());

}



//=========



void StrCpyFmt(inout Str s,Tpi tpi,int w,int d,int opt) {

    char buf[80];

    int n=tpi.ptm.getf(tpi.pv,buf,w,d,opt);

    StrCpyMem(s,buf,n);

}



void StrCpyFmt(inout Str s,char    t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,byte    t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,ubyte   t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,short   t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,ushort  t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,int     t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,uint    t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,long    t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,ulong   t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,float   t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,double  t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,ifloat  t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,idouble t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,cfloat  t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCpyFmt(inout Str s,cdouble t,int w,int d,int opt) {  StrCpyFmt(s,TypeRetTpi(t),w,d,opt);  }



//=========



void StrCatFmt(inout Str s,Tpi tpi,int w,int d,int opt) {

    char buf[80];

    int n=tpi.ptm.getf(tpi.pv,buf,w,d,opt);

    StrCatMem(s,buf,n);

}



void StrCatFmt(inout Str s,char    t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,byte    t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,ubyte   t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,short   t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,ushort  t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,int     t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,uint    t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,long    t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,ulong   t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,float   t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,double  t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,ifloat  t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,idouble t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,cfloat  t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }

void StrCatFmt(inout Str s,cdouble t,int w,int d,int opt) {  StrCatFmt(s,TypeRetTpi(t),w,d,opt);  }



//=========



Str IntRetStr(int i)

{

    char buf[20];

    char [] ret;

    int n=sprintf(buf,"%d",i);

    ret.length=n;

    ret[0..n]=buf[0..n];

    return ret;

}



//=========



void iWriteMemCpy(inout iWriteMem o,Tpi tpi) {

    char buf[256];

    int n=tpi.ptm.gets(tpi.pv,buf);

    o.WriteMem(buf,n);

}



void iWriteMemCpy(inout iWriteMem o,char    t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,byte    t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,ubyte   t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,short   t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,ushort  t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,int     t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,uint    t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,long    t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,ulong   t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,float   t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,double  t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,ifloat  t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,idouble t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,cfloat  t) {  iWriteMemCpy(o,TypeRetTpi(t));  }

void iWriteMemCpy(inout iWriteMem o,cdouble t) {  iWriteMemCpy(o,TypeRetTpi(t));  }



//=========



alias strlen StrLen;

alias memset.memcpy MemCpy;



void StrDelLen(char *s,int n)

{

   int len=StrLen(s);

   if(n>len) {

      n=len;

   }

   MemCpy(s,s+n,len-n+1);

}



void StrStrip(char *s)

{

   int h=StrLen(s);

   while(h && s[h-1]==' ') {

      s[--h]=0;

   }

}



void StrStripChr(char *s,char c)

{

   int h=StrLen(s);

   while(h && s[h-1]==c) {

      s[--h]=0;

   }

}



void StrStripFront(char *s)

{

   int n=0;

   while(s[n]==' ') {

      n++;

   }

   if(n) {

      StrDelLen(s,n);

   }

}



void StrStripBoth(char *s)

{

   StrStrip(s);

   StrStripFront(s);

}



void StrStripChrFront(char *s,char c)

{

   int n=0;

   while(s[n]==c) {

      n++;

   }

   if(n) {

      StrDelLen(s,n);

   }

}



